routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('home');
});

Route::group(['prefix' => 'master', 'as' => 'master.'], function () {
    Route::resource('power_unit', 'Master\PowerUnitController');
    Route::get('power_unit_datatables', ['uses' => 'Master\PowerUnitController@datatables', 'as' => 'power_unit.datatables'] );
    Route::resource('maps_leaflet', 'Master\MapsLeafletController');
    Route::resource('query_data', 'Master\QueryDataController');
    Route::resource('number_pattern', 'Master\NumberPatternController');
    Route::get('pattern_one', ['uses' => 'Master\NumberPatternController@NumberPatternOne', 'as' => 'pattern_one'] );
    Route::get('pattern_two', ['uses' => 'Master\NumberPatternController@NumberPatternTwo', 'as' => 'pattern_two'] );
    Route::get('pattern_three', ['uses' => 'Master\NumberPatternController@NumberPatternThree', 'as' => 'pattern_three'] );
    Route::get('pattern_four', ['uses' => 'Master\NumberPatternController@NumberPatternFour', 'as' => 'pattern_four'] );
});

app/Models/PowerUnit.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Model;

class PowerUnit extends Model {

    protected $primaryKey = 'id_power_unit';

    protected $table = 'power_unit';

    public $timestamps = false;

    protected $dateFormat = 'Y-m-d H:i:sO';

    protected $fillable = ['power_unit_num', 'description', 'id_corporation', 'id_location', 'id_poer_unit_type', 'is_active', 'insert_user', 'insert_date', 'update_user', 'update_date'];
}

app/Models/PowerUnitType.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Model;

class PowerUnitType extends Model {

    protected $primaryKey = 'id_power_unit_type';

    protected $table = 'power_unit_type';

    public $timestamps = false;

    protected $dateFormat = 'Y-m-d H:i:sO';

    protected $fillable = ['power_unit_type_xid', 'description', 'insert_user','insert_date', 'update_user', 'update_date'];
}

app/Http/Controllers/Master/PowerUnitController.php
<?php

namespace App\Http\Controllers\Master;

use App\Http\Controllers\Controller;
use App\Models\Corporation;
use App\Models\Location;
use App\Models\PowerUnitType;
use Carbon\Carbon;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;
use Vinkla\Hashids\Facades\Hashids;
use Yajra\DataTables\Facades\DataTables;

class PowerUnitController extends Controller
{

    public function index(Request $request)
    {

        return view('power_unit.index');

    }

    public function datatables(Request $request)
    {

        $result = DB::table('power_unit')
            ->select('power_unit.power_unit_num AS power_unit_num', 'power_unit.description AS description', 'corporation.corporation as corporation', 'location.location_name as location', 'power_unit_type.power_unit_type_xid as power_unit_type_xid', 'power_unit.is_active AS is_active', 'power_unit.insert_date AS insert_date', 'power_unit.update_date AS update_date')
            ->leftJoin('corporation', 'corporation.id_corporation', '=', 'power_unit.id_corporation')
            ->leftJoin('location', 'location.id_location', '=', 'power_unit.id_location')
            ->leftJoin('power_unit_type', 'power_unit_type.id_power_unit_type', '=', 'power_unit.id_power_unit_type')
            ->where('power_unit.is_active', '=', TRUE);

        return DataTables::of($result)
            ->addColumn('action', function ($result) {
                /*
                $url_edit = "<a href='".route('ic.setting_library_online.edit', ['id' => Hashids::encode($result->id)])."' title='".trans('app.edit_title')."' data-toggle='tooltip' class='btn btn-outline'><span class='ti-settings icon-lg'></span> </a>";
                $url_delete = "<form class='delete' action='" . route('ic.setting_library_online.delete', ['id' => Hashids::encode($result->id)]) . "' method='POST'>
                    " . csrf_field() . "<button type='submit' class='btn btn-outline text-danger' title='" . trans('app.delete_title') . "' data-toggle='tooltip'><i class='ti-trash icon-xl'></i></button></form>";
                    */
                $url_delete = "";
                $url_edit = "";
                return
                    '<div class="btn-group">'
                    . $url_edit . $url_delete .
                    '</div>';
            })
            ->editColumn('power_unit_num', function ($result) {
                return $result->power_unit_num ? $result->power_unit_num : '-';
            })
            ->filterColumn('power_unit_num', function ($query, $keyword) {
                $sql = "power_unit.power_unit_num ilike ?";
                $query->whereRaw($sql, ["%{$keyword}%"]);
            })
            ->editColumn('description', function ($result) {
                return $result->description ? $result->description : '-';
            })
            ->filterColumn('description', function ($query, $keyword) {
                $sql = "power_unit.description ilike ?";
                $query->whereRaw($sql, ["%{$keyword}%"]);
            })
            ->editColumn('corporation', function ($result) {
                return $result->corporation ? $result->corporation : '-';
            })
            ->filterColumn('corporation', function ($query, $keyword) {
                $sql = "corporation.corporation ilike ?";
                $query->whereRaw($sql, ["%{$keyword}%"]);
            })
            ->editColumn('location', function ($result) {
                return $result->location ? $result->location : '-';
            })
            ->filterColumn('location', function ($query, $keyword) {
                $sql = "location.location_name ilike ?";
                $query->whereRaw($sql, ["%{$keyword}%"]);
            })
            ->editColumn('power_unit_type_xid', function ($result) {
                return $result->power_unit_type_xid ? $result->power_unit_type_xid : '-';
            })
            ->filterColumn('power_unit_type_xid', function ($query, $keyword) {
                $sql = "power_unit_type.power_unit_type_xid ilike ?";
                $query->whereRaw($sql, ["%{$keyword}%"]);
            })
            ->editColumn('is_active', function ($result) {
                return $result->is_active == "TRUE" ? "AKTIF" : 'TIDAK AKTIF';
            })
            ->editColumn('insert_date', function ($result) {
                setlocale(LC_TIME, 'id_ID.utf8');
                return $result->insert_date ? with(new Carbon($result->insert_date))->formatLocalized('%A, %d %B %Y') : '-';
            })
            ->editColumn('update_date', function ($result) {
                setlocale(LC_TIME, 'id_ID.utf8');
                return $result->update_date ? with(new Carbon($result->update_date))->formatLocalized('%A, %d %B %Y') : '-';
            })
            ->make(true);
    }

    public function create(Request $request)
    {
        $corporation = Corporation::select('corporation','id_corporation')->get();
        $location = Location::select(DB::raw("CONCAT(location_name,' - ',city,' - ',province) AS loc_name"),"id_location")->get();
        $powerUnitType = PowerUnitType::select('power_unit_type_xid','id_power_unit_type')->get();
        return view('power_unit.create',compact('corporation', 'location','powerUnitType'));

    }

    public function store(Request $request)
    {
        $data['nik'] = $request->get('nik_employee');
        $data['name_employee'] = $request->get('name_employee');
        $data['status'] = $request->get('status_employee');
        $data['created_by'] = "1";
        $data['created_at'] = Carbon::now();
        Corporation::create($data);
        return redirect()->route('master.employee.index')->with(['success' => 'Data pegawai sukses disimpan!']);
    }

    public function edit($id)
    {

        return view('power_unit.edit');

    }

    public function update(Request $request)
    {

    }

    public function delete(Request $request)
    {

    }

}

resources/views/power_unit/create.blade.php
@extends('layout.default')
@section('content')
    <!-- Content Header (Page header) -->
    <section class="content-header">
        <div class="container-fluid">
            <div class="row mb-2">
                <div class="col-sm-6">
                </div>
                <div class="col-sm-6">
                    <ol class="breadcrumb float-sm-right">
                        <li class="breadcrumb-item"><a href="/">Home</a></li>
                        <li class="breadcrumb-item"><a href="{{ route('master.power_unit.index') }}">Power Unit</a></li>
                        <li class="breadcrumb-item active">Buat Data Power Unit</li>
                    </ol>
                </div>
            </div>
        </div><!-- /.container-fluid -->
    </section>

    <!-- Main content -->
    <section class="content">

        <!-- Default box -->
        <div class="card card-blue">
            <div class="card-header">
                <h3 class="card-title"><i class="fas fa-tachometer-alt"></i> Buat Data Power Unit</h3>

                <div class="card-tools">
                    <button type="button" class="btn btn-tool" data-card-widget="collapse" title="Collapse">
                        <i class="fas fa-minus"></i>
                    </button>
                </div>
            </div>
            <div class="card-body">
                <div>
                    <a href="{{ route('master.power_unit.index') }}" class="btn btn-warning"><i class="fas fa-arrow-left"></i> Kembali</a>
                </div>
                <br/>
                {!! Form::open(['method' => 'POST', 'route' => ['master.power_unit.store'], 'files' => true, 'id' => 'master_power_unit_data']) !!}

                <div class="form-group row">
                    <label for="nik" class="col-sm-3 col-form-label text-right">Power Unit Num</label>
                    <div class="col-sm-8">
                        <input type="text" required="" class="form-control" id="power_unit_num" name="power_unit_num" placeholder="Masukkan power unit num">
                    </div>
                </div>
                <div class="form-group row">
                    <label for="name" class="col-sm-3 col-form-label text-right">Description</label>
                    <div class="col-sm-8">
                        <input type="text" required="" class="form-control" id="description" name="description" placeholder="Masukkan description">
                    </div>
                </div>
                <div class="form-group row">
                    <label for="name" class="col-sm-3 col-form-label text-right">Corporation</label>
                    <div class="col-sm-8">
                        <select class="form-control select2" name="id_corporation" id="id_corporation">
                            <option value="0">Choose one corporation</option>
                            @foreach($corporation as $corp)
                                <option value="{{ $corp->id_corporation }}">{{ $corp->corporation }}</option>
                            @endforeach
                        </select>
                    </div>
                </div>
                <div class="form-group row">
                    <label for="name" class="col-sm-3 col-form-label text-right">Location</label>
                    <div class="col-sm-8">
                        <select class="form-control select2" name="id_location" id="id_location">
                            <option value="0">Choose one location</option>
                            @foreach($location as $loc)
                                <option value="{{ $loc->id_location }}">{{ $loc->loc_name }}</option>
                            @endforeach
                        </select>
                    </div>
                </div>
                <div class="form-group row">
                    <label for="name" class="col-sm-3 col-form-label text-right">Power Unit Type</label>
                    <div class="col-sm-8">
                        <select class="form-control select2" name="id_power_unit_type" id="id_power_unit_type">
                            <option value="0">Choose one Power Unit Type</option>
                            @foreach($powerUnitType as $put)
                                <option value="{{ $put->id_power_unit_type }}">{{ $put->power_unit_type_xid }}</option>
                            @endforeach
                        </select>
                    </div>
                </div>
                <div class="form-group row">
                    <label for="status" class="col-sm-3 col-form-label text-right">Status Aktif</label>
                    <div class="col-sm-8">
                        <select class="custom-select rounded-0" id="is_active" name="is_active">
                            <option value="" disabled selected hidden>PILIH SALAH SATU</option>
                            <option value="true">AKTIF</option>
                            <option value="false">TIDAK AKTIF</option>
                        </select>
                    </div>
                </div>

            </div>
            <!-- /.card-body -->
            <div class="card-footer" style="text-align: center">
                <button type="submit" value="save" name="save" id="btn-submit" class="btn btn-danger"><i class="fas fa-save mR-10"></i> Simpan</button>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
                <a href="{{ route('master.power_unit.index') }}" class="btn btn-outline-dark"><i class="fas fa-window-close"></i> Batalkan</a>
            </div>
            {!! Form::close() !!}
        </div>
        <!-- /.card -->

    </section>
    <!-- /.content -->
@stop
@section('css')
<style>
    .form-group {margin-bottom: 3rem !important;}
</style>
@stop
@section('js')
<script>
    $(document).ready(function() {
            $('#id_corporation').select2({
                placeholder: "Please select corporation..."
            });
            $('#master_power_unit_data').validate({
                onkeyup: false,
                ignore: [],
                errorClass: "error",
                rules: {
                    power_unit_num: {required : true},
                    description: {required : true},
                    id_corporation: {required : true},
                },
                messages: {
                    power_unit_num: "Tolong diisi",
                    description: "Tolong diisi",
                    id_corporation: "Tolong dipilih",
                },
                 errorPlacement: function (error, element) {
                  error.addClass('invalid-feedback');
                  error.insertAfter(element);
                },
                highlight: function (element, errorClass, validClass) {
                  $(element).addClass('is-invalid');
                },
                unhighlight: function (element, errorClass, validClass) {
                  $(element).removeClass('is-invalid');
                },
                submitHandler: function (form) {
                    //form.submit();
                    $.ajax({
                        xhr: function () {
                            var xhr = new window.XMLHttpRequest();
                            var percentComplete;
                            xhr.upload.addEventListener("progress", function (evt) {
                                if (evt.lengthComputable) {
                                    var percentComplete = evt.loaded / evt.total;
                                    percentComplete = parseInt(percentComplete * 100);
                                    $('.progress-bar').attr('aria-valuenow', percentComplete);
                                    $('.progress-bar').attr('style', 'width:' + percentComplete + '%');
                                    $('div.progress-bar').text(percentComplete + '%');
                                }
                            }, false);

                            return xhr;
                        },
                        url: '{{ route('master.power_unit.store') }}',
                        type: "POST",
                        cache: false,
                        processData: false,
                        contentType: false,
                        data: new FormData(form),
                        headers: {'X-CSRF-TOKEN': $('input[name="_token"]').val()},
                        beforeSend: function () {
                            Swal.fire({
                                width: 700,
                                title: 'Document is saving',
                                html: '<br><div class="progress" style="height: 40px;"><div class="progress-bar progress-bar-striped progress-bar-animated font-progressbar" role="progressbar" aria-valuenow="0" aria-valuemin="0" aria-valuemax="100" style="width:0%"></div></div><br>',
                                showConfirmButton: false,
                                allowOutsideClick: false,
                            });
                            window.onbeforeunload = function () {
                                return "Are you sure you want to leave? The data maybe will not saved";
                            }
                        },
                        success: function (data) {
                            Swal.fire({
                                width: 700,
                                type: (data['status'] === 200) ? 'success' : 'error',
                                html: '<h5>' + data['message'] + '</h5>',
                            }).then(function () {
                                window.location.href = (data['status'] === 200) ? data['payload'] : '{{ route('master.power_unit.index') }}';
                            });
                        },
                        error: function (jqXHR, textStatus) {
                            $("#lo_file").val(null);
                            const result = JSON.parse(jqXHR.responseText);
                            Swal.fire({
                                width: 700,
                                type: 'error',
                                html: '<h5>' + (result['message'] ? result['message'] : 'Error, please contact Administrator') + '</h5>',
                            }).then(function () {
                                window.location.href = '{{ route('master.power_unit.index') }}';
                            });
                            return false;
                            window.onbeforeunload = null;
                        },
                        complete: function () {
                            window.onbeforeunload = null;
                        }
                    });
                    return false;
                }
            });
            $("select").on("select2:close", function (e) {
                $(this).valid();
            });
    });
</script>
@stop

resources/views/power_unit/edit.blade.php
<?php

resources/views/power_unit/index.blade.php
@extends('layout.default')

@section('content')
    <section class="content-header">
    </section>
    <section class="content">
        <div class="card card-blue">
            <div class="card-header">
                <h3 class="card-title"><i class="fas fa-tachometer-alt"></i> Data Power Unit</h3>

                <div class="card-tools">
                    <button type="button" class="btn btn-tool" data-card-widget="collapse" title="Collapse">
                        <i class="fas fa-minus"></i>
                    </button>
                </div>
            </div>
            <div class="card-body">
                <div>
                    <a href="{{ route('master.power_unit.create') }}" class="btn btn-success"><i class="fas fa-plus"></i> Tambah Data</a>
                </div>
                <br/>
                    <table id="dataTables" class="table table-striped table-bordered" cellspacing="0" width="100%">
                        <thead>
                            <tr>
                                <th>Power Unit</th>
                                <th>Description</th>
                                <th>Corporation</th>
                                <th>Location</th>
                                <th>Power Unit Type</th>
                                <th>Status</th>
                                <th>Created At</th>
                                <th>Updated At</th>
                                <th>Action</th>
                            </tr>
                        </thead>
                    </table>
            </div>
        </div>
    </section>
@endsection

@section('css')
<link href="{{ asset('/css/custom.css') }}" rel="stylesheet">
@endsection

@section('js')
    <script>
    $(document).ready(function() {
        var table = $('#dataTables').DataTable({
            processing: true,
            serverSide: true,
            responsive: true,
            pageLength: 10,
            lengthMenu: [[5,10, 25, 50, 100, -1], [5,10, 25, 50, 100, "All"]],
            ajax: '{{ route('master.power_unit.datatables') }}',
            columns: [
                {data: 'power_unit_num', name: 'power_unit_num'},
                {data: 'description', name: 'description'},
                {data: 'corporation', name: 'corporation'},
                {data: 'location', name: 'location'},
                {data: 'power_unit_type_xid', name: 'power_unit_type_xid'},
                {data: 'is_active', name: 'is_active'},
                {data: 'insert_date', name: 'insert_date'},
                {data: 'update_date', name: 'update_date'},
                {data: 'action', name: 'action', orderable: false, searchable: false},

            ],
            order: [[ 2, 'asc' ], [ 3, 'asc' ]],
            columnDefs: [
                { "width": "10%", "targets": 0 },
                { "width": "15%", "targets": 1 },
                { "width": "10%", "targets": 2 },
                { "width": "15%", "targets": 3 },
                { "width": "10%", "targets": 4 },
                { "width": "8%", "targets": 5 },
                { "width": "13%", "targets": 6 },
                { "width": "13%", "targets": 7 },
                { "width": "13%", "targets": 8 },
            ],
            fnInitComplete: function() {
                $('.dataTables_scrollHead').css('overflow', 'auto');
                $('.dataTables_scrollHead').on('scroll', function () {
                    $('.dataTables_scrollBody').scrollLeft($(this).scrollLeft());
                });
                $('.dataTables_scrollBody').on('scroll', function () {
                    $('.dataTables_scrollHead').scrollLeft($(this).scrollLeft());
                });
            },
            oLanguage: {
                sProcessing: '<span style="font-size: 16px; font-weight: 800; margin-bottom: 30px;">Please wait...</span><span><img src="{!! asset('images/loading.gif') !!}" width="50px" height="50px"/></span>',
            },
        });
    });
</script>
@stop